"use strict";
/*--------------------------------------------------------*\
|                                                          |
|                          hprose                          |
|                                                          |
| Official WebSite: https://hprose.com                     |
|                                                          |
| Caller.ts                                                |
|                                                          |
| Caller for TypeScript.                                   |
|                                                          |
| LastModified: Mar 19, 2019                               |
| Author: Ma Bingyao <andot@hprose.com>                    |
|                                                          |
\*________________________________________________________*/
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var rpc_core_1 = require("@hprose/rpc-core");
function makeInvoke(caller, id, fullname) {
    return function () {
        return caller.invoke(id, fullname, Array.prototype.slice.call(arguments));
    };
}
function setMethods(caller, id, service, namespace, name, methods) {
    if (service[name] !== undefined) {
        return;
    }
    service[name] = Object.create(null);
    if (!Array.isArray(methods)) {
        methods = [methods];
    }
    namespace = namespace + name + '_';
    for (var i = 0; i < methods.length; i++) {
        var node = methods[i];
        if (typeof node === 'string') {
            service[name][node] = makeInvoke(caller, id, namespace + node);
        }
        else {
            for (var n in node) {
                setMethods(caller, id, service[name], namespace, n, node[n]);
            }
        }
    }
}
function useService(caller, id, functions) {
    var root = rpc_core_1.normalize(functions);
    var service = Object.create(null);
    for (var i = 0; i < root.length; i++) {
        var node = root[i];
        if (typeof node === 'string') {
            if (service[node] === undefined) {
                service[node] = makeInvoke(caller, id, node);
            }
        }
        else {
            for (var name_1 in node) {
                setMethods(caller, id, service, '', name_1, node[name_1]);
            }
        }
    }
    return service;
}
var ServiceProxyHandler = /** @class */ (function () {
    function ServiceProxyHandler(client, id, namespace) {
        this.client = client;
        this.id = id;
        this.namespace = namespace;
    }
    ServiceProxyHandler.prototype.get = function (target, p, receiver) {
        if (typeof p === 'symbol') {
            return undefined;
        }
        if (p === 'then') {
            return undefined;
        }
        if (!(p in target)) {
            target[p] = makeInvoke(this.client, this.id, this.namespace ? this.namespace + '_' + p : '' + p);
        }
        return target[p];
    };
    return ServiceProxyHandler;
}());
var Caller = /** @class */ (function () {
    function Caller(service) {
        var _this = this;
        this.service = service;
        this.counter = 0;
        this.calls = Object.create(null);
        this.results = Object.create(null);
        this.responders = Object.create(null);
        this.onlines = Object.create(null);
        this.timeout = 120000;
        this.handler = function (name, args, context, next) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                context.invoke = function (fullname, args) {
                    if (args === void 0) { args = []; }
                    return _this.invoke(_this.id(context), fullname, args);
                };
                return [2 /*return*/, next(name, args, context)];
            });
        }); };
        var close = new rpc_core_1.Method(this.close, '!!', this);
        close.passContext = true;
        var begin = new rpc_core_1.Method(this.begin, '!', this);
        begin.passContext = true;
        var end = new rpc_core_1.Method(this.end, '=', this, [Array]);
        end.passContext = true;
        this.service.add(close)
            .add(begin)
            .add(end)
            .use(this.handler);
    }
    Caller.prototype.id = function (context) {
        if (context.requestHeaders['id']) {
            return context.requestHeaders['id'].toString();
        }
        throw new Error('Client unique id not found');
    };
    Caller.prototype.send = function (id, responder) {
        var calls = this.calls[id];
        if (calls) {
            if (calls.length === 0) {
                return false;
            }
            this.calls[id] = [];
            responder.resolve(calls);
            return true;
        }
        return false;
    };
    Caller.prototype.response = function (id) {
        if (this.responders[id]) {
            var responder = this.responders[id];
            if (this.send(id, responder)) {
                delete this.responders[id];
            }
        }
    };
    Caller.prototype.stop = function (context) {
        var id = this.id(context);
        if (this.responders[id]) {
            var responder = this.responders[id];
            delete this.responders[id];
            responder.resolve();
        }
        return id;
    };
    Caller.prototype.close = function (context) {
        var id = this.stop(context);
        delete this.onlines[id];
    };
    Caller.prototype.begin = function (context) {
        return __awaiter(this, void 0, void 0, function () {
            var id, responder, timeoutId_1;
            return __generator(this, function (_a) {
                id = this.stop(context);
                this.onlines[id] = true;
                responder = rpc_core_1.defer();
                if (!this.send(id, responder)) {
                    this.responders[id] = responder;
                    if (this.timeout > 0) {
                        timeoutId_1 = setTimeout(function () {
                            responder.resolve([]);
                        }, this.timeout);
                        responder.promise.then(function () {
                            clearTimeout(timeoutId_1);
                        });
                    }
                }
                return [2 /*return*/, responder.promise];
            });
        });
    };
    Caller.prototype.end = function (results, context) {
        var id = this.id(context);
        for (var i = 0, n = results.length; i < n; ++i) {
            var _a = results[i], index = _a[0], value = _a[1], error = _a[2];
            if (this.results[id] && this.results[id][index]) {
                var result = this.results[id][index];
                delete this.results[id][index];
                if (error) {
                    result.reject(new Error(error));
                }
                else {
                    result.resolve(value);
                }
            }
        }
    };
    Caller.prototype.invoke = function (id, fullname, args) {
        if (args === void 0) { args = []; }
        return __awaiter(this, void 0, void 0, function () {
            var index, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(args.length > 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, Promise.all(args)];
                    case 1:
                        args = _a.sent();
                        _a.label = 2;
                    case 2:
                        ++this.counter;
                        if (this.counter > 0x7FFFFFFF) {
                            this.counter = 0;
                        }
                        index = this.counter;
                        result = rpc_core_1.defer();
                        if (this.calls[id] === undefined) {
                            this.calls[id] = [];
                        }
                        this.calls[id].push([index, fullname, args]);
                        if (this.results[id] === undefined) {
                            this.results[id] = Object.create(null);
                        }
                        this.results[id][index] = result;
                        this.response(id);
                        return [2 /*return*/, result.promise];
                }
            });
        });
    };
    Caller.prototype.useService = function (id, arg) {
        var namespace;
        if (Array.isArray(arg)) {
            return useService(this, id, arg);
        }
        else {
            namespace = arg;
        }
        return new Proxy(Object.create(null), new ServiceProxyHandler(this, id, namespace));
    };
    Caller.prototype.useServiceAsync = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var fullnames;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.invoke(id, '~')];
                    case 1:
                        fullnames = _a.sent();
                        return [2 /*return*/, useService(this, id, fullnames)];
                }
            });
        });
    };
    Caller.prototype.exists = function (id) {
        return id in this.onlines;
    };
    Caller.prototype.idlist = function () {
        return Object.keys(this.onlines);
    };
    return Caller;
}());
exports.Caller = Caller;
//# sourceMappingURL=Caller.js.map